/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.compute.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* The instance view of a resource.
*/
public abstract class ResourceInstanceView {
    private ArrayList<InstanceViewStatus> statuses;
    
    /**
    * Optional. Gets or sets the resource status information.
    * @return The Statuses value.
    */
    public ArrayList<InstanceViewStatus> getStatuses() {
        return this.statuses;
    }
    
    /**
    * Optional. Gets or sets the resource status information.
    * @param statusesValue The Statuses value.
    */
    public void setStatuses(final ArrayList<InstanceViewStatus> statusesValue) {
        this.statuses = statusesValue;
    }
    
    /**
    * Initializes a new instance of the ResourceInstanceView class.
    *
    */
    public ResourceInstanceView() {
        this.setStatuses(new LazyArrayList<InstanceViewStatus>());
    }
}
