/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.compute.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* Describes a storage profile.
*/
public class StorageProfile {
    private ArrayList<DataDisk> dataDisks;
    
    /**
    * Optional. Gets or sets the data disks.
    * @return The DataDisks value.
    */
    public ArrayList<DataDisk> getDataDisks() {
        return this.dataDisks;
    }
    
    /**
    * Optional. Gets or sets the data disks.
    * @param dataDisksValue The DataDisks value.
    */
    public void setDataDisks(final ArrayList<DataDisk> dataDisksValue) {
        this.dataDisks = dataDisksValue;
    }
    
    private ImageReference imageReference;
    
    /**
    * Optional. Gets or sets the image reference.
    * @return The ImageReference value.
    */
    public ImageReference getImageReference() {
        return this.imageReference;
    }
    
    /**
    * Optional. Gets or sets the image reference.
    * @param imageReferenceValue The ImageReference value.
    */
    public void setImageReference(final ImageReference imageReferenceValue) {
        this.imageReference = imageReferenceValue;
    }
    
    private OSDisk oSDisk;
    
    /**
    * Optional. Gets or sets the OS disk.
    * @return The OSDisk value.
    */
    public OSDisk getOSDisk() {
        return this.oSDisk;
    }
    
    /**
    * Optional. Gets or sets the OS disk.
    * @param oSDiskValue The OSDisk value.
    */
    public void setOSDisk(final OSDisk oSDiskValue) {
        this.oSDisk = oSDiskValue;
    }
    
    /**
    * Initializes a new instance of the StorageProfile class.
    *
    */
    public StorageProfile() {
        this.setDataDisks(new LazyArrayList<DataDisk>());
    }
}
