/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.network.models;

/**
* IP configuration of application gateway
*/
public class ApplicationGatewayIPConfiguration extends ChildResource {
    private String provisioningState;
    
    /**
    * Optional. Gets or sets Provisioning state of the application gateway
    * subnet resource Updating/Deleting/Failed
    * @return The ProvisioningState value.
    */
    public String getProvisioningState() {
        return this.provisioningState;
    }
    
    /**
    * Optional. Gets or sets Provisioning state of the application gateway
    * subnet resource Updating/Deleting/Failed
    * @param provisioningStateValue The ProvisioningState value.
    */
    public void setProvisioningState(final String provisioningStateValue) {
        this.provisioningState = provisioningStateValue;
    }
    
    private ResourceId subnet;
    
    /**
    * Optional. Gets or sets the reference of the subnet resource.A subnet from
    * where appliation gateway gets its private address
    * @return The Subnet value.
    */
    public ResourceId getSubnet() {
        return this.subnet;
    }
    
    /**
    * Optional. Gets or sets the reference of the subnet resource.A subnet from
    * where appliation gateway gets its private address
    * @param subnetValue The Subnet value.
    */
    public void setSubnet(final ResourceId subnetValue) {
        this.subnet = subnetValue;
    }
}
