/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.network.models;

/**
* The type of Azure hop the packet should be sent to.
*/
public abstract class RouteNextHopType {
    /**
    * Represents an Azure S2S VPN Gateway.
    */
    public static final String VIRTUALNETWORKGATEWAY = "VirtualNetworkGateway";
    
    /**
    * Represents the local virtual network. For instance, if you have two
    * subnets, 10.1.0.0/16 and 10.2.0.0/16 in the same virtual network, the
    * route for each subnet in the route table will have a next hop value of
    * Local.
    */
    public static final String VNETLOCAL = "VnetLocal";
    
    /**
    * Represents the default Internet gateway provided by the Azure
    * Infrastructure
    */
    public static final String INTERNET = "Internet";
    
    /**
    * Represents a virtual appliance you added to your Azure virtual network.
    */
    public static final String VIRTUALAPPLIANCE = "VirtualAppliance";
    
    /**
    * Represents a black hole. Packets forwarded to a black hole will not be
    * forwarded at all.
    */
    public static final String NONE = "None";
}
