/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.resources.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* Resource Type
*/
public class ResourceType {
    private String displayName;
    
    /**
    * Optional. Gets or sets the resource type display name
    * @return The DisplayName value.
    */
    public String getDisplayName() {
        return this.displayName;
    }
    
    /**
    * Optional. Gets or sets the resource type display name
    * @param displayNameValue The DisplayName value.
    */
    public void setDisplayName(final String displayNameValue) {
        this.displayName = displayNameValue;
    }
    
    private String name;
    
    /**
    * Optional. Gets or sets the resource type name
    * @return The Name value.
    */
    public String getName() {
        return this.name;
    }
    
    /**
    * Optional. Gets or sets the resource type name
    * @param nameValue The Name value.
    */
    public void setName(final String nameValue) {
        this.name = nameValue;
    }
    
    private ArrayList<Operation> operations;
    
    /**
    * Optional. Gets or sets the resource type operations
    * @return The Operations value.
    */
    public ArrayList<Operation> getOperations() {
        return this.operations;
    }
    
    /**
    * Optional. Gets or sets the resource type operations
    * @param operationsValue The Operations value.
    */
    public void setOperations(final ArrayList<Operation> operationsValue) {
        this.operations = operationsValue;
    }
    
    /**
    * Initializes a new instance of the ResourceType class.
    *
    */
    public ResourceType() {
        this.setOperations(new LazyArrayList<Operation>());
    }
}
