/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.sql.models;

/**
* Represents the properties of a recommended Azure SQL Database being upgraded.
*/
public class RecommendedDatabaseProperties {
    private String name;
    
    /**
    * Optional. Gets or sets the name of the Azure SQL Database being upgraded.
    * @return The Name value.
    */
    public String getName() {
        return this.name;
    }
    
    /**
    * Optional. Gets or sets the name of the Azure SQL Database being upgraded.
    * @param nameValue The Name value.
    */
    public void setName(final String nameValue) {
        this.name = nameValue;
    }
    
    private String targetEdition;
    
    /**
    * Optional. Gets or sets the target edition for the Azure SQL Database
    * being upgraded.
    * @return The TargetEdition value.
    */
    public String getTargetEdition() {
        return this.targetEdition;
    }
    
    /**
    * Optional. Gets or sets the target edition for the Azure SQL Database
    * being upgraded.
    * @param targetEditionValue The TargetEdition value.
    */
    public void setTargetEdition(final String targetEditionValue) {
        this.targetEdition = targetEditionValue;
    }
    
    private String targetServiceLevelObjective;
    
    /**
    * Optional. Gets or sets the target Service Level Objective for the Azure
    * SQL Database being upgraded.
    * @return The TargetServiceLevelObjective value.
    */
    public String getTargetServiceLevelObjective() {
        return this.targetServiceLevelObjective;
    }
    
    /**
    * Optional. Gets or sets the target Service Level Objective for the Azure
    * SQL Database being upgraded.
    * @param targetServiceLevelObjectiveValue The TargetServiceLevelObjective
    * value.
    */
    public void setTargetServiceLevelObjective(final String targetServiceLevelObjectiveValue) {
        this.targetServiceLevelObjective = targetServiceLevelObjectiveValue;
    }
}
