/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.storage.models;

import java.net.URI;

/**
* The URIs that are used to perform a retrieval of a public blob, queue or
* table object.
*/
public class Endpoints {
    private URI blob;
    
    /**
    * Optional. Gets the blob endpoint.
    * @return The Blob value.
    */
    public URI getBlob() {
        return this.blob;
    }
    
    /**
    * Optional. Gets the blob endpoint.
    * @param blobValue The Blob value.
    */
    public void setBlob(final URI blobValue) {
        this.blob = blobValue;
    }
    
    private URI file;
    
    /**
    * Optional. Gets the file endpoint.
    * @return The File value.
    */
    public URI getFile() {
        return this.file;
    }
    
    /**
    * Optional. Gets the file endpoint.
    * @param fileValue The File value.
    */
    public void setFile(final URI fileValue) {
        this.file = fileValue;
    }
    
    private URI queue;
    
    /**
    * Optional. Gets the queue endpoint.
    * @return The Queue value.
    */
    public URI getQueue() {
        return this.queue;
    }
    
    /**
    * Optional. Gets the queue endpoint.
    * @param queueValue The Queue value.
    */
    public void setQueue(final URI queueValue) {
        this.queue = queueValue;
    }
    
    private URI table;
    
    /**
    * Optional. Gets the table endpoint.
    * @return The Table value.
    */
    public URI getTable() {
        return this.table;
    }
    
    /**
    * Optional. Gets the table endpoint.
    * @param tableValue The Table value.
    */
    public void setTable(final URI tableValue) {
        this.table = tableValue;
    }
}
