/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.compute.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* Configures the Windows Remote Management service on the virtual machine,
* which enables remote Windows PowerShell.
*/
public class AdditionalUnattendContentSettings {
    private ArrayList<UnattendPassSettings> unattendPasses;
    
    /**
    * Optional. Specifies the unattend passes
    * @return The UnattendPasses value.
    */
    public ArrayList<UnattendPassSettings> getUnattendPasses() {
        return this.unattendPasses;
    }
    
    /**
    * Optional. Specifies the unattend passes
    * @param unattendPassesValue The UnattendPasses value.
    */
    public void setUnattendPasses(final ArrayList<UnattendPassSettings> unattendPassesValue) {
        this.unattendPasses = unattendPassesValue;
    }
    
    /**
    * Initializes a new instance of the AdditionalUnattendContentSettings class.
    *
    */
    public AdditionalUnattendContentSettings() {
        this.setUnattendPasses(new LazyArrayList<UnattendPassSettings>());
    }
}
