/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.scheduler.models;

/**
* Specifies the state for a cloud service resource.
*/
public abstract class GetCloudServiceResourceState {
    /**
    * The resource state is unknown, there may have been a communicaiton
    * failure, or the resource has not yet been processed.
    */
    public static final String UNKNOWN = "Unknown";
    
    /**
    * The resource provider did not respond with information for the resource.
    */
    public static final String NOTFOUND = "NotFound";
    
    /**
    * The resource has started and is running fine.
    */
    public static final String STARTED = "Started";
    
    /**
    * The resource was stopped due to an issue.
    */
    public static final String STOPPED = "Stopped";
    
    /**
    * The resource was temporarily put on hold. This may be due to a monetary
    * event.
    */
    public static final String PAUSED = "Paused";
}
