/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.scheduler.models;

/**
* Active Directory OAuth authentication for job
*/
public class AADOAuthAuthentication extends HttpAuthentication {
    private String audience;
    
    /**
    * Optional. Gets or sets the audience.
    * @return The Audience value.
    */
    public String getAudience() {
        return this.audience;
    }
    
    /**
    * Optional. Gets or sets the audience.
    * @param audienceValue The Audience value.
    */
    public void setAudience(final String audienceValue) {
        this.audience = audienceValue;
    }
    
    private String clientId;
    
    /**
    * Optional. Gets or sets the client id.
    * @return The ClientId value.
    */
    public String getClientId() {
        return this.clientId;
    }
    
    /**
    * Optional. Gets or sets the client id.
    * @param clientIdValue The ClientId value.
    */
    public void setClientId(final String clientIdValue) {
        this.clientId = clientIdValue;
    }
    
    private String secret;
    
    /**
    * Optional. Gets or sets the secret.
    * @return The Secret value.
    */
    public String getSecret() {
        return this.secret;
    }
    
    /**
    * Optional. Gets or sets the secret.
    * @param secretValue The Secret value.
    */
    public void setSecret(final String secretValue) {
        this.secret = secretValue;
    }
    
    private String tenant;
    
    /**
    * Optional. Gets or sets the tenant.
    * @return The Tenant value.
    */
    public String getTenant() {
        return this.tenant;
    }
    
    /**
    * Optional. Gets or sets the tenant.
    * @param tenantValue The Tenant value.
    */
    public void setTenant(final String tenantValue) {
        this.tenant = tenantValue;
    }
}
